# combo - content management system
# Copyright (C) 2015  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import requests
import urllib

from combo.utils import sign_url
from combo.apps.wcs.utils import get_wcs_services


def get_wcs_data(endpoint, params=None):
    # consider only first wcs instance (FIXME)
    wcs_site = get_wcs_services().values()[0]
    wcs_site_url = wcs_site['url']
    if not wcs_site_url.endswith('/'):
        wcs_site_url += '/'
    url = wcs_site_url + endpoint
    if params:
        url += '?' + urllib.urlencode(params.items())
    url = sign_url(url, wcs_site.get('secret'))
    response = requests.get(url)
    response.raise_for_status()
    return response.json()
